SystemOrganization addCategory: #'Seaside-Pharo-Core'!

!MessageSend methodsFor: '*seaside-pharo-core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 6/7/2007 22:14'!
snapshotCopy
	^ self copy! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:53'!
seasideMimeDocument
	^ self contents seasideMimeDocument! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'StuartHerring 6/19/2010 10:05'!
seasideMimeDocumentType: aMimetype
	^self seasideMimeDocument mimeType: aMimetype; yourself! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 4/20/2007 20:43'!
snapshotCopy
	^ self copy! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:54'!
seasideMimeDocument
	^ WAMimeDocument on: self content mimeType: self contentType! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'StuartHerring 6/19/2010 10:03'!
seasideMimeDocumentType: aMimeType
	^self seasideMimeDocument mimeType: aMimeType; yourself! !

!BlockContext methodsFor: '*seaside-pharo-core' stamp: 'lr 4/19/2009 13:30'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!BlockClosure methodsFor: '*seaside-pharo-core' stamp: 'lr 4/8/2009 13:32'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 11/16/2007 17:11'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
snapshotCopy
	^ self copy! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/19/2007 23:13'!
restoreFromSnapshot: anObject
	self copyFrom: anObject! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/15/2008 18:45'!
snapshotCopy
	^ self shallowCopy! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'jf 9/22/2008 13:21'!
defaultMimeType
	^ WAMimeType imageGif! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'mb 6/12/2006 14:01'!
mimeType
	^ self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 16:39'!
seasideMimeDocument
	^ self seasideMimeDocumentType: self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	"Converts the receiver to a WAMimeDocument. The argument should ideally be an instance for WAMimeType. For various crappy reasons Strings and nil are also allowed."
	
	| aStream writer |
	aStream := RWBinaryOrTextStream on: String new.
	writer := self writerForMimeType: aMimeType seasideMimeType.
	writer isNil ifTrue: [ self error: 'no writer for ', aMimeType greaseString, ' found' ].
	writer putForm: (self asFormOfDepth: 32) onStream: aStream.
	^ WAMimeDocument on: aStream contents mimeType: aMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'lr 5/13/2010 12:19'!
writerForMimeType: mimeType
	| sub |
	mimeType main ~= 'image'
		ifTrue: [ ^ nil ]. 
	"First token is assumed to be 'image'"
	sub := mimeType sub.
	(sub = 'jpg' or: [ sub = 'jpeg' ])
		ifTrue: [ ^ Smalltalk at: #JPEGReadWriter2 ifAbsent: [ Smalltalk at: #PluginBasedJPEGReadWriter ifAbsent: [ nil ] ] ].
	sub = 'png' ifTrue: [ ^PNGReadWriter ].
	sub = 'pcx' ifTrue: [ ^PCXReadWriter ].
	sub = 'bmp' ifTrue: [ ^BMPReadWriter ].
	sub = 'gif' ifTrue: [ ^GIFReadWriter ].
	^nil! !

!GRPackage class methodsFor: '*seaside-pharo-core' stamp: 'lr 2/17/2010 15:12'!
seasidePharoCore
	^ self new
		name: 'Seaside-Pharo-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Pharo-Core';
		url: #seasideUrl;
		yourself! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
snapshotCopy
	^ self copy! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:50'!
seasideMimeDocument
	^ self imageForm seasideMimeDocument! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	^ self imageForm seasideMimeDocumentType: aMimeType! !
